### Hierarchy

- TextField
  - FPS

### Implements

- IEventDispatcher
- IBitmapDrawable

## Index

### Constructors

- constructor

### Properties

- alpha
- antiAliasType
- autoSize
- background
- backgroundColor
- blendMode
- border
- borderColor
- bottomScrollV
- cacheAsBitmap
- cacheAsBitmapMatrix
- caretIndex
- currentFPS
- defaultTextFormat
- displayAsPassword
- doubleClickEnabled
- embedFonts
- filters
- focusRect
- gridFitType
- height
- htmlText
- length
- loaderInfo
- mask
- maxChars
- maxScrollH
- maxScrollV
- mouseEnabled
- mouseWheelEnabled
- mouseX
- mouseY
- multiline
- name
- needsSoftKeyboard
- numLines
- opaqueBackground
- parent
- restrict
- root
- rotation
- scale9Grid
- scaleX
- scaleY
- scrollH
- scrollRect
- scrollV
- selectable
- selectionBeginIndex
- selectionEndIndex
- shader
- sharpness
- softKeyboardInputAreaOfInterest
- stage
- tabEnabled
- tabIndex
- text
- textColor
- textHeight
- textWidth
- transform
- type
- visible
- width
- wordWrap
- x
- y

### Methods

- addEventListener
- appendText
- dispatchEvent
- getBounds
- getCharBoundaries
- getCharIndexAtPoint
- getFirstCharInParagraph
- getLineIndexAtPoint
- getLineIndexOfChar
- getLineLength
- getLineMetrics
- getLineOffset
- getLineText
- getParagraphLength
- getRect
- getTextFormat
- get_alpha
- get_antiAliasType
- get_autoSize
- get_background
- get_backgroundColor
- get_blendMode
- get_border
- get_borderColor
- get_bottomScrollV
- get_cacheAsBitmap
- get_cacheAsBitmapMatrix
- get_caretIndex
- get_defaultTextFormat
- get_displayAsPassword
- get_embedFonts
- get_filters
- get_gridFitType
- get_height
- get_htmlText
- get_length
- get_loaderInfo
- get_mask
- get_maxChars
- get_maxScrollH
- get_maxScrollV
- get_mouseWheelEnabled
- get_mouseX
- get_mouseY
- get_multiline
- get_name
- get_numLines
- get_restrict
- get_root
- get_rotation
- get_scaleX
- get_scaleY
- get_scrollH
- get_scrollRect
- get_scrollV
- get_selectable
- get_selectionBeginIndex
- get_selectionEndIndex
- get_shader
- get_sharpness
- get_stage
- get_tabEnabled
- get_tabIndex
- get_text
- get_textColor
- get_textHeight
- get_textWidth
- get_transform
- get_type
- get_visible
- get_width
- get_wordWrap
- get_x
- get_y
- globalToLocal
- hasEventListener
- hitTestObject
- hitTestPoint
- invalidate
- localToGlobal
- removeEventListener
- replaceSelectedText
- replaceText
- requestSoftKeyboard
- setSelection
- setTextFormat
- set_alpha
- set_antiAliasType
- set_autoSize
- set_background
- set_backgroundColor
- set_blendMode
- set_border
- set_borderColor
- set_cacheAsBitmap
- set_cacheAsBitmapMatrix
- set_caretIndex
- set_defaultTextFormat
- set_displayAsPassword
- set_embedFonts
- set_filters
- set_gridFitType
- set_height
- set_htmlText
- set_length
- set_mask
- set_maxChars
- set_mouseWheelEnabled
- set_multiline
- set_name
- set_restrict
- set_rotation
- set_scaleX
- set_scaleY
- set_scrollH
- set_scrollRect
- set_scrollV
- set_selectable
- set_shader
- set_sharpness
- set_stage
- set_tabEnabled
- set_tabIndex
- set_text
- set_textColor
- set_transform
- set_type
- set_visible
- set_width
- set_wordWrap
- set_x
- set_y
- toString
- willTrigger

## Constructors

### constructor

- new FPS(x?: number, y?: number, color?: number): FPS

- Overrides TextField.constructor

  - Defined in lib/openfl/display/FPS.d.ts:9

  #### Parameters

  - ##### Optional x: number

  - ##### Optional y: number

  - ##### Optional color: number

  #### Returns FPS

## Properties

### alpha

alpha: number

Inherited from DisplayObject.alpha

- Defined in lib/openfl/display/DisplayObject.d.ts:161

Indicates the alpha transparency value of the object specified. Valid values are 0(fully transparent) to 1(fully opaque). The default value is

1. Display objects with `alpha` set to 0 are active, even though they are invisible.

### antiAliasType

antiAliasType: AntiAliasType

Inherited from TextField.antiAliasType

- Defined in lib/openfl/text/TextField.d.ts:105

The type of anti-aliasing used for this text field. Use `flash.text.AntiAliasType` constants for this property. You can control this setting only if the font is embedded(with the `embedFonts` property set to `true`). The default setting is `flash.text.AntiAliasType.NORMAL`.

To set values for this property, use the following string values:

### autoSize

autoSize: TextFieldAutoSize

Inherited from TextField.autoSize

- Defined in lib/openfl/text/TextField.d.ts:152

Controls automatic sizing and alignment of text fields. Acceptable values for the `TextFieldAutoSize` constants: `TextFieldAutoSize.NONE`(the default), `TextFieldAutoSize.LEFT`, `TextFieldAutoSize.RIGHT`, and `TextFieldAutoSize.CENTER`.

If `autoSize` is set to `TextFieldAutoSize.NONE` (the default) no resizing occurs.

If `autoSize` is set to `TextFieldAutoSize.LEFT`, the text is treated as left-justified text, meaning that the left margin of the text field remains fixed and any resizing of a single line of the text field is on the right margin. If the text includes a line break(for example, `"\n"` or `"\r"`), the bottom is also resized to fit the next line of text. If `wordWrap` is also set to `true`, only the bottom of the text field is resized and the right side remains fixed.

If `autoSize` is set to `TextFieldAutoSize.RIGHT`, the text is treated as right-justified text, meaning that the right margin of the text field remains fixed and any resizing of a single line of the text field is on the left margin. If the text includes a line break(for example, `"\n" or "\r")`, the bottom is also resized to fit the next line of text. If `wordWrap` is also set to `true`, only the bottom of the text field is resized and the left side remains fixed.

If `autoSize` is set to `TextFieldAutoSize.CENTER`, the text is treated as center-justified text, meaning that any resizing of a single line of the text field is equally distributed to both the right and left margins. If the text includes a line break(for example, `"\n"` or `"\r"`), the bottom is also resized to fit the next line of text. If `wordWrap` is also set to `true`, only the bottom of the text field is resized and the left and right sides remain fixed.

throws

  ArgumentError The `autoSize` specified is not a member of flash.text.TextFieldAutoSize.

### background

background: boolean

Inherited from TextField.background

- Defined in lib/openfl/text/TextField.d.ts:166

Specifies whether the text field has a background fill. If `true`, the text field has a background fill. If `false`, the text field has no background fill. Use the `backgroundColor` property to set the background color of a text field.

default

  false

### backgroundColor

backgroundColor: number

Inherited from TextField.backgroundColor

- Defined in lib/openfl/text/TextField.d.ts:178

The color of the text field background. The default value is `0xFFFFFF`(white). This property can be retrieved or set, even if there currently is no background, but the color is visible only if the text field has the `background` property set to `true`.

### blendMode

blendMode: BlendMode

Inherited from DisplayObject.blendMode

- Defined in lib/openfl/display/DisplayObject.d.ts:190

A value from the BlendMode class that specifies which blend mode to use. A bitmap can be drawn internally in two ways. If you have a blend mode enabled or an external clipping mask, the bitmap is drawn by adding a bitmap-filled square shape to the vector render. If you attempt to set this property to an invalid value, Flash runtimes set the value to `BlendMode.NORMAL`.

The `blendMode` property affects each pixel of the display object. Each pixel is composed of three constituent colors(red, green, and blue), and each constituent color has a value between 0x00 and 0xFF. Flash Player or Adobe AIR compares each constituent color of one pixel in the movie clip with the corresponding color of the pixel in the background. For example, if `blendMode` is set to `BlendMode.LIGHTEN`, Flash Player or Adobe AIR compares the red value of the display object with the red value of the background, and uses the lighter of the two as the value for the red component of the displayed color.

The following table describes the `blendMode` settings. The BlendMode class defines string values you can use. The illustrations in the table show `blendMode` values applied to a circular display object(2) superimposed on another display object(1).

### border

border: boolean

Inherited from TextField.border

- Defined in lib/openfl/text/TextField.d.ts:190

Specifies whether the text field has a border. If `true`, the text field has a border. If `false`, the text field has no border. Use the `borderColor` property to set the border color.

default

  false

### borderColor

borderColor: number

Inherited from TextField.borderColor

- Defined in lib/openfl/text/TextField.d.ts:201

The color of the text field border. The default value is `0x000000`(black). This property can be retrieved or set, even if there currently is no border, but the color is visible only if the text field has the `border` property set to `true`.

### bottomScrollV

bottomScrollV: number

Inherited from TextField.bottomScrollV

- Defined in lib/openfl/text/TextField.d.ts:215

An integer(1-based index) that indicates the bottommost line that is currently visible in the specified text field. Think of the text field as a window onto a block of text. The `scrollV` property is the 1-based index of the topmost visible line in the window.

All the text between the lines indicated by `scrollV` and `bottomScrollV` is currently visible in the text field.

### cacheAsBitmap

cacheAsBitmap: boolean

Inherited from DisplayObject.cacheAsBitmap

- Defined in lib/openfl/display/DisplayObject.d.ts:251

All vector data for a display object that has a cached bitmap is drawn to the bitmap instead of the main display. If `cacheAsBitmapMatrix` is null or unsupported, the bitmap is then copied to the main display as unstretched, unrotated pixels snapped to the nearest pixel boundaries. Pixels are mapped 1 to 1 with the parent object. If the bounds of the bitmap change, the bitmap is recreated instead of being stretched.

If `cacheAsBitmapMatrix` is non-null and supported, the object is drawn to the off-screen bitmap using that matrix and the stretched and/or rotated results of that rendering are used to draw the object to the main display.

No internal bitmap is created unless the `cacheAsBitmap` property is set to `true`.

After you set the `cacheAsBitmap` property to `true`, the rendering does not change, however the display object performs pixel snapping automatically. The animation speed can be significantly faster depending on the complexity of the vector content.

The `cacheAsBitmap` property is automatically set to `true` whenever you apply a filter to a display object(when its `filter` array is not empty), and if a display object has a filter applied to it, `cacheAsBitmap` is reported as `true` for that display object, even if you set the property to `false`. If you clear all filters for a display object, the `cacheAsBitmap` setting changes to what it was last set to.

A display object does not use a bitmap even if the `cacheAsBitmap` property is set to `true` and instead renders from vector data in the following cases:

- The bitmap is too large. In AIR 1.5 and Flash Player 10, the maximum size for a bitmap image is 8,191 pixels in width or height, and the total number of pixels cannot exceed 16,777,215 pixels.(So, if a bitmap image is 8,191 pixels wide, it can only be 2,048 pixels high.) In Flash Player 9 and earlier, the limitation is is 2880 pixels in height and 2,880 pixels in width.
- The bitmap fails to allocate(out of memory error).

The `cacheAsBitmap` property is best used with movie clips that have mostly static content and that do not scale and rotate frequently. With such movie clips, `cacheAsBitmap` can lead to performance increases when the movie clip is translated(when its _x_ and _y_ position is changed).

### cacheAsBitmapMatrix

cacheAsBitmapMatrix: Matrix

Inherited from DisplayObject.cacheAsBitmapMatrix

- Defined in lib/openfl/display/DisplayObject.d.ts:256

### caretIndex

caretIndex: number

Inherited from TextField.caretIndex

- Defined in lib/openfl/text/TextField.d.ts:228

The index of the insertion point(caret) position. If no insertion point is displayed, the value is the position the insertion point would be if you restored focus to the field(typically where the insertion point last was, or 0 if the field has not had focus).

Selection span indexes are zero-based(for example, the first position is 0, the second position is 1, and so on).

### currentFPS

currentFPS: number

- Defined in lib/openfl/display/FPS.d.ts:9

### defaultTextFormat

defaultTextFormat: TextFormat

Inherited from TextField.defaultTextFormat

- Defined in lib/openfl/text/TextField.d.ts:262

Specifies the format applied to newly inserted text, such as text entered by a user or text inserted with the `replaceSelectedText()` method.

Note: When selecting characters to be replaced with `setSelection()` and `replaceSelectedText()`, the `defaultTextFormat` will be applied only if the text has been selected up to and including the last character. Here is an example:

    var my_txt:TextField new TextField();
    my_txt.text = "Flash Macintosh version"; var my_fmt:TextFormat = new
    TextFormat(); my_fmt.color = 0xFF0000; my_txt.defaultTextFormat = my_fmt;
    my_txt.setSelection(6,15); // partial text selected - defaultTextFormat
    not applied my_txt.setSelection(6,23); // text selected to end -
    defaultTextFormat applied my_txt.replaceSelectedText("Windows version");

When you access the `defaultTextFormat` property, the returned TextFormat object has all of its properties defined. No property is `null`.

Note: You can't set this property if a style sheet is applied to the text field.

throws

  Error This method cannot be used on a text field with a style sheet.

### displayAsPassword

displayAsPassword: boolean

Inherited from TextField.displayAsPassword

- Defined in lib/openfl/text/TextField.d.ts:279

Specifies whether the text field is a password text field. If the value of this property is `true`, the text field is treated as a password text field and hides the input characters using asterisks instead of the actual characters. If `false`, the text field is not treated as a password text field. When password mode is enabled, the Cut and Copy commands and their corresponding keyboard shortcuts will not function. This security mechanism prevents an unscrupulous user from using the shortcuts to discover a password on an unattended computer.

default

  false

### doubleClickEnabled

doubleClickEnabled: boolean

Inherited from InteractiveObject.doubleClickEnabled

- Defined in lib/openfl/display/InteractiveObject.d.ts:1072

Specifies whether the object receives `doubleClick` events. The default value is `false`, which means that by default an InteractiveObject instance does not receive `doubleClick` events. If the `doubleClickEnabled` property is set to `true`, the instance receives `doubleClick` events within its bounds. The `mouseEnabled` property of the InteractiveObject instance must also be set to `true` for the object to receive `doubleClick` events.

No event is dispatched by setting this property. You must use the `addEventListener()` method to add an event listener for the `doubleClick` event.

### embedFonts

embedFonts: boolean

Inherited from TextField.embedFonts

- Defined in lib/openfl/text/TextField.d.ts:297

Specifies whether to render by using embedded font outlines. If `false`, Flash Player renders the text field by using device fonts.

If you set the `embedFonts` property to `true` for a text field, you must specify a font for that text by using the `font` property of a TextFormat object applied to the text field. If the specified font is not embedded in the SWF file, the text is not displayed.

default

  false

### filters

filters: Array<BitmapFilter>

Inherited from DisplayObject.filters

- Defined in lib/openfl/display/DisplayObject.d.ts:337

An indexed array that contains each filter object currently associated with the display object. The openfl.filters package contains several classes that define specific filters you can use.

Filters can be applied in Flash Professional at design time, or at run time by using ActionScript code. To apply a filter by using ActionScript, you must make a temporary copy of the entire `filters` array, modify the temporary array, then assign the value of the temporary array back to the `filters` array. You cannot directly add a new filter object to the `filters` array.

To add a filter by using ActionScript, perform the following steps (assume that the target display object is named `myDisplayObject`):

1. Create a new filter object by using the constructor method of your chosen filter class.
2. Assign the value of the `myDisplayObject.filters` array to a temporary array, such as one named `myFilters`.
3. Add the new filter object to the `myFilters` temporary array.
4. Assign the value of the temporary array to the `myDisplayObject.filters` array.

If the `filters` array is undefined, you do not need to use a temporary array. Instead, you can directly assign an array literal that contains one or more filter objects that you create. The first example in the Examples section adds a drop shadow filter by using code that handles both defined and undefined `filters` arrays.

To modify an existing filter object, you must use the technique of modifying a copy of the `filters` array:

1. Assign the value of the `filters` array to a temporary array, such as one named `myFilters`.
2. Modify the property by using the temporary array, `myFilters`. For example, to set the quality property of the first filter in the array, you could use the following code: `myFilters[0].quality = 1;`
3. Assign the value of the temporary array to the `filters` array.

At load time, if a display object has an associated filter, it is marked to cache itself as a transparent bitmap. From this point forward, as long as the display object has a valid filter list, the player caches the display object as a bitmap. This source bitmap is used as a source image for the filter effects. Each display object usually has two bitmaps: one with the original unfiltered source display object and another for the final image after filtering. The final image is used when rendering. As long as the display object does not change, the final image does not need updating.

The openfl.filters package includes classes for filters. For example, to create a DropShadow filter, you would write:

throws

  ArgumentError When `filters` includes a ShaderFilter and the shader output type is not compatible with this operation(the shader must specify a `pixel4` output).

throws

  ArgumentError When `filters` includes a ShaderFilter and the shader doesn't specify any image input or the first input is not an `image4` input.

throws

  ArgumentError When `filters` includes a ShaderFilter and the shader specifies an image input that isn't provided.

throws

  ArgumentError When `filters` includes a ShaderFilter, a ByteArray or Vector. instance as a shader input, and the `width` and `height` properties aren't specified for the ShaderInput object, or the specified values don't match the amount of data in the input data. See the `ShaderInput.input` property for more information.

### focusRect

focusRect: boolean | null

Inherited from InteractiveObject.focusRect

- Defined in lib/openfl/display/InteractiveObject.d.ts:1074

### gridFitType

gridFitType: GridFitType

Inherited from TextField.gridFitType

- Defined in lib/openfl/text/TextField.d.ts:316

The type of grid fitting used for this text field. This property applies only if the `flash.text.AntiAliasType` property of the text field is set to `flash.text.AntiAliasType.ADVANCED`.

The type of grid fitting used determines whether Flash Player forces strong horizontal and vertical lines to fit to a pixel or subpixel grid, or not at all.

For the `flash.text.GridFitType` property, you can use the following string values:

default

  pixel

### height

height: number

Inherited from DisplayObject.height

- Defined in lib/openfl/display/DisplayObject.d.ts:352

Indicates the height of the display object, in pixels. The height is calculated based on the bounds of the content of the display object. When you set the `height` property, the `scaleY` property is adjusted accordingly, as shown in the following code:

Except for TextField and Video objects, a display object with no content(such as an empty sprite) has a height of 0, even if you try to set `height` to a different value.

### htmlText

htmlText: string

Inherited from TextField.htmlText

- Defined in lib/openfl/text/TextField.d.ts:329

Contains the HTML representation of the text field contents.

Flash Player supports the following HTML tags:

Flash Player and AIR also support explicit character codes, such as &(ASCII ampersand) and €(Unicode € symbol).

### length

length: number

Inherited from TextField.length

- Defined in lib/openfl/text/TextField.d.ts:338

The number of characters in a text field. A character such as tab (`\t`) counts as one character.

### loaderInfo

loaderInfo: LoaderInfo

Inherited from DisplayObject.loaderInfo

- Defined in lib/openfl/display/DisplayObject.d.ts:370

Returns a LoaderInfo object containing information about loading the file to which this display object belongs. The `loaderInfo` property is defined only for the root display object of a SWF file or for a loaded Bitmap(not for a Bitmap that is drawn with ActionScript). To find the `loaderInfo` object associated with the SWF file that contains a display object named `myDisplayObject`, use `myDisplayObject.root.loaderInfo`.

A large SWF file can monitor its download by calling `this.root.loaderInfo.addEventListener(Event.COMPLETE, func)`.

### mask

mask: DisplayObject

Inherited from DisplayObject.mask

- Defined in lib/openfl/display/DisplayObject.d.ts:405

The calling display object is masked by the specified `mask` object. To ensure that masking works when the Stage is scaled, the `mask` display object must be in an active part of the display list. The `mask` object itself is not drawn. Set `mask` to `null` to remove the mask.

To be able to scale a mask object, it must be on the display list. To be able to drag a mask Sprite object(by calling its `startDrag()` method), it must be on the display list. To call the `startDrag()` method for a mask sprite based on a `mouseDown` event being dispatched by the sprite, set the sprite's `buttonMode` property to `true`.

When display objects are cached by setting the `cacheAsBitmap` property to `true` an the `cacheAsBitmapMatrix` property to a Matrix object, both the mask and the display object being masked must be part of the same cached bitmap. Thus, if the display object is cached, then the mask must be a child of the display object. If an ancestor of the display object on the display list is cached, then the mask must be a child of that ancestor or one of its descendents. If more than one ancestor of the masked object is cached, then the mask must be a descendent of the cached container closest to the masked object in the display list.

Note: A single `mask` object cannot be used to mask more than one calling display object. When the `mask` is assigned to a second display object, it is removed as the mask of the first object, and that object's `mask` property becomes `null`.

### maxChars

maxChars: number

Inherited from TextField.maxChars

- Defined in lib/openfl/text/TextField.d.ts:352

The maximum number of characters that the text field can contain, as entered by a user. A script can insert more text than `maxChars` allows; the `maxChars` property indicates only how much text a user can enter. If the value of this property is `0`, a user can enter an unlimited amount of text.

default

  0

### maxScrollH

maxScrollH: number

Inherited from TextField.maxScrollH

- Defined in lib/openfl/text/TextField.d.ts:360

The maximum value of `scrollH`.

### maxScrollV

maxScrollV: number

Inherited from TextField.maxScrollV

- Defined in lib/openfl/text/TextField.d.ts:367

The maximum value of `scrollV`.

### mouseEnabled

mouseEnabled: boolean

Inherited from InteractiveObject.mouseEnabled

- Defined in lib/openfl/display/InteractiveObject.d.ts:1092

Specifies whether this object receives mouse, or other user input, messages. The default value is `true`, which means that by default any InteractiveObject instance that is on the display list receives mouse events or other user input events. If `mouseEnabled` is set to `false`, the instance does not receive any mouse events(or other user input events like keyboard events). Any children of this instance on the display list are not affected. To change the `mouseEnabled` behavior for all children of an object on the display list, use `openfl.display.DisplayObjectContainer.mouseChildren`.

No event is dispatched by setting this property. You must use the `addEventListener()` method to create interactive functionality.

### mouseWheelEnabled

mouseWheelEnabled: boolean

Inherited from TextField.mouseWheelEnabled

- Defined in lib/openfl/text/TextField.d.ts:371

### mouseX

mouseX: number

Inherited from DisplayObject.mouseX

- Defined in lib/openfl/display/DisplayObject.d.ts:417

Indicates the x coordinate of the mouse or user input device position, in pixels.

Note: For a DisplayObject that has been rotated, the returned x coordinate will reflect the non-rotated object.

### mouseY

mouseY: number

Inherited from DisplayObject.mouseY

- Defined in lib/openfl/display/DisplayObject.d.ts:428

Indicates the y coordinate of the mouse or user input device position, in pixels.

Note: For a DisplayObject that has been rotated, the returned y coordinate will reflect the non-rotated object.

### multiline

multiline: boolean

Inherited from TextField.multiline

- Defined in lib/openfl/text/TextField.d.ts:388

Indicates whether field is a multiline text field. If the value is `true`, the text field is multiline; if the value is `false`, the text field is a single-line text field. In a field of type `TextFieldType.INPUT`, the `multiline` value determines whether the `Enter` key creates a new line(a value of `false`, and the `Enter` key is ignored). If you paste text into a `TextField` with a `multiline` value of `false`, newlines are stripped out of the text.

default

  false

### name

name: string

Inherited from DisplayObject.name

- Defined in lib/openfl/display/DisplayObject.d.ts:442

Indicates the instance name of the DisplayObject. The object can be identified in the child list of its parent display object container by calling the `getChildByName()` method of the display object container.

throws

  IllegalOperationError If you are attempting to set this property on an object that was placed on the timeline in the Flash authoring tool.

### needsSoftKeyboard

needsSoftKeyboard: boolean

Inherited from InteractiveObject.needsSoftKeyboard

- Defined in lib/openfl/display/InteractiveObject.d.ts:1116

Specifies whether a virtual keyboard(an on-screen, software keyboard) should display when this InteractiveObject instance receives focus.

By default, the value is `false` and focusing an InteractiveObject instance does not raise a soft keyboard. If the `needsSoftKeyboard` property is set to `true`, the runtime raises a soft keyboard when the InteractiveObject instance is ready to accept user input. An InteractiveObject instance is ready to accept user input after a programmatic call to set the Stage `focus` property or a user interaction, such as a "tap." If the client system has a hardware keyboard available or does not support virtual keyboards, then the soft keyboard is not raised.

The InteractiveObject instance dispatches `softKeyboardActivating`, `softKeyboardActivate`, and `softKeyboardDeactivate` events when the soft keyboard raises and lowers.

Note: This property is not supported in AIR applications on iOS.

### numLines

numLines: number

Inherited from TextField.numLines

- Defined in lib/openfl/text/TextField.d.ts:398

Defines the number of text lines in a multiline text field. If `wordWrap` property is set to `true`, the number of lines increases when text wraps.

### opaqueBackground

opaqueBackground: number | null

Inherited from DisplayObject.opaqueBackground

- Defined in lib/openfl/display/DisplayObject.d.ts:471

Specifies whether the display object is opaque with a certain background color. A transparent bitmap contains alpha channel data and is drawn transparently. An opaque bitmap has no alpha channel(and renders faster than a transparent bitmap). If the bitmap is opaque, you specify its own background color to use.

If set to a number value, the surface is opaque(not transparent) with the RGB background color that the number specifies. If set to `null`(the default value), the display object has a transparent background.

The `opaqueBackground` property is intended mainly for use with the `cacheAsBitmap` property, for rendering optimization. For display objects in which the `cacheAsBitmap` property is set to true, setting `opaqueBackground` can improve rendering performance.

The opaque background region is not matched when calling the `hitTestPoint()` method with the `shapeFlag` parameter set to `true`.

The opaque background region does not respond to mouse events.

### parent

parent: DisplayObjectContainer

Inherited from DisplayObject.parent

- Defined in lib/openfl/display/DisplayObject.d.ts:487

Indicates the DisplayObjectContainer object that contains this display object. Use the `parent` property to specify a relative path to display objects that are above the current display object in the display list hierarchy.

You can use `parent` to move up multiple levels in the display list as in the following:

throws

  SecurityError The parent display object belongs to a security sandbox to which you do not have access. You can avoid this situation by having the parent movie call the `Security.allowDomain()` method.

### restrict

restrict: string

Inherited from TextField.restrict

- Defined in lib/openfl/text/TextField.d.ts:448

Indicates the set of characters that a user can enter into the text field. If the value of the `restrict` property is `null`, you can enter any character. If the value of the `restrict` property is an empty string, you cannot enter any character. If the value of the `restrict` property is a string of characters, you can enter only characters in the string into the text field. The string is scanned from left to right. You can specify a range by using the hyphen (-) character. Only user interaction is restricted; a script can put any text into the text field. This property does not synchronize with the Embed font options in the Property inspector.

If the string begins with a caret(^) character, all characters are initially accepted and succeeding characters in the string are excluded from the set of accepted characters. If the string does not begin with a caret(^) character, no characters are initially accepted and succeeding characters in the string are included in the set of accepted characters.

The following example allows only uppercase characters, spaces, and numbers to be entered into a text field: `my_txt.restrict = "A-Z 0-9";`

The following example includes all characters, but excludes lowercase letters: `my_txt.restrict = "^a-z";`

You can use a backslash to enter a ^ or - verbatim. The accepted backslash sequences are -, \^ or \. The backslash must be an actual character in the string, so when specified in ActionScript, a double backslash must be used. For example, the following code includes only the dash(-) and caret(^): `my_txt.restrict = "\\-\\^";`

The ^ can be used anywhere in the string to toggle between including characters and excluding characters. The following code includes only uppercase letters, but excludes the uppercase letter Q: `my_txt.restrict = "A-Z^Q";`

You can use the `\u` escape sequence to construct `restrict` strings. The following code includes only the characters from ASCII 32(space) to ASCII 126(tilde). `my_txt.restrict = "\u0020-\u007E";`

default

  null

### root

root: DisplayObject

Inherited from DisplayObject.root

- Defined in lib/openfl/display/DisplayObject.d.ts:515

For a display object in a loaded SWF file, the `root` property is the top-most display object in the portion of the display list's tree structure represented by that SWF file. For a Bitmap object representing a loaded image file, the `root` property is the Bitmap object itself. For the instance of the main class of the first SWF file loaded, the `root` property is the display object itself. The `root` property of the Stage object is the Stage object itself. The `root` property is set to `null` for any display object that has not been added to the display list, unless it has been added to a display object container that is off the display list but that is a child of the top-most display object in a loaded SWF file.

For example, if you create a new Sprite object by calling the `Sprite()` constructor method, its `root` property is `null` until you add it to the display list(or to a display object container that is off the display list but that is a child of the top-most display object in a SWF file).

For a loaded SWF file, even though the Loader object used to load the file may not be on the display list, the top-most display object in the SWF file has its `root` property set to itself. The Loader object does not have its `root` property set until it is added as a child of a display object for which the `root` property is set.

### rotation

rotation: number

Inherited from DisplayObject.rotation

- Defined in lib/openfl/display/DisplayObject.d.ts:527

Indicates the rotation of the DisplayObject instance, in degrees, from its original orientation. Values from 0 to 180 represent clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or subtracted from 360 to obtain a value within the range. For example, the statement `my_video.rotation = 450` is the same as `my_video.rotation = 90`.

### scale9Grid

scale9Grid: Rectangle

Inherited from DisplayObject.scale9Grid

- Defined in lib/openfl/display/DisplayObject.d.ts:594

The current scaling grid that is in effect. If set to `null`, the entire display object is scaled normally when any scale transformation is applied.

When you define the `scale9Grid` property, the display object is divided into a grid with nine regions based on the `scale9Grid` rectangle, which defines the center region of the grid. The eight other regions of the grid are the following areas:

- The upper-left corner outside of the rectangle
- The area above the rectangle
- The upper-right corner outside of the rectangle
- The area to the left of the rectangle
- The area to the right of the rectangle
- The lower-left corner outside of the rectangle
- The area below the rectangle
- The lower-right corner outside of the rectangle

You can think of the eight regions outside of the center(defined by the rectangle) as being like a picture frame that has special rules applied to it when scaled.

When the `scale9Grid` property is set and a display object is scaled, all text and gradients are scaled normally; however, for other types of objects the following rules apply:

- Content in the center region is scaled normally.
- Content in the corners is not scaled.
- Content in the top and bottom regions is scaled horizontally only. Content in the left and right regions is scaled vertically only.
- All fills(including bitmaps, video, and gradients) are stretched to fit their shapes.

If a display object is rotated, all subsequent scaling is normal(and the `scale9Grid` property is ignored).

For example, consider the following display object and a rectangle that is applied as the display object's `scale9Grid`:

A common use for setting `scale9Grid` is to set up a display object to be used as a component, in which edge regions retain the same width when the component is scaled.

throws

  ArgumentError If you pass an invalid argument to the method.

### scaleX

scaleX: number

Inherited from DisplayObject.scaleX

- Defined in lib/openfl/display/DisplayObject.d.ts:604

Indicates the horizontal scale(percentage) of the object as applied from the registration point. The default registration point is(0,0). 1.0 equals 100% scale.

Scaling the local coordinate system changes the `x` and `y` property values, which are defined in whole pixels.

### scaleY

scaleY: number

Inherited from DisplayObject.scaleY

- Defined in lib/openfl/display/DisplayObject.d.ts:617

Indicates the vertical scale(percentage) of an object as applied from the registration point of the object. The default registration point is(0,0). 1.0 is 100% scale.

Scaling the local coordinate system changes the `x` and `y` property values, which are defined in whole pixels.

### scrollH

scrollH: number

Inherited from TextField.scrollH

- Defined in lib/openfl/text/TextField.d.ts:469

The current horizontal scrolling position. If the `scrollH` property is 0, the text is not horizontally scrolled. This property value is an integer that represents the horizontal position in pixels.

The units of horizontal scrolling are pixels, whereas the units of vertical scrolling are lines. Horizontal scrolling is measured in pixels because most fonts you typically use are proportionally spaced; that is, the characters can have different widths. Flash Player performs vertical scrolling by line because users usually want to see a complete line of text rather than a partial line. Even if a line uses multiple fonts, the height of the line adjusts to fit the largest font in use.

Note: The `scrollH` property is zero-based, not 1-based like the `scrollV` vertical scrolling property.

### scrollRect

scrollRect: Rectangle

Inherited from DisplayObject.scrollRect

- Defined in lib/openfl/display/DisplayObject.d.ts:648

The scroll rectangle bounds of the display object. The display object is cropped to the size defined by the rectangle, and it scrolls within the rectangle when you change the `x` and `y` properties of the `scrollRect` object.

The properties of the `scrollRect` Rectangle object use the display object's coordinate space and are scaled just like the overall display object. The corner bounds of the cropped window on the scrolling display object are the origin of the display object(0,0) and the point defined by the width and height of the rectangle. They are not centered around the origin, but use the origin to define the upper-left corner of the area. A scrolled display object always scrolls in whole pixel increments.

You can scroll an object left and right by setting the `x` property of the `scrollRect` Rectangle object. You can scroll an object up and down by setting the `y` property of the `scrollRect` Rectangle object. If the display object is rotated 90° and you scroll it left and right, the display object actually scrolls up and down.

### scrollV

scrollV: number

Inherited from TextField.scrollV

- Defined in lib/openfl/text/TextField.d.ts:488

The vertical position of text in a text field. The `scrollV` property is useful for directing users to a specific paragraph in a long passage, or creating scrolling text fields.

The units of vertical scrolling are lines, whereas the units of horizontal scrolling are pixels. If the first line displayed is the first line in the text field, scrollV is set to 1(not 0). Horizontal scrolling is measured in pixels because most fonts are proportionally spaced; that is, the characters can have different widths. Flash performs vertical scrolling by line because users usually want to see a complete line of text rather than a partial line. Even if there are multiple fonts on a line, the height of the line adjusts to fit the largest font in use.

### selectable

selectable: boolean

Inherited from TextField.selectable

- Defined in lib/openfl/text/TextField.d.ts:511

A Boolean value that indicates whether the text field is selectable. The value `true` indicates that the text is selectable. The `selectable` property controls whether a text field is selectable, not whether a text field is editable. A dynamic text field can be selectable even if it is not editable. If a dynamic text field is not selectable, the user cannot select its text.

If `selectable` is set to `false`, the text in the text field does not respond to selection commands from the mouse or keyboard, and the text cannot be copied with the Copy command. If `selectable` is set to `true`, the text in the text field can be selected with the mouse or keyboard, and the text can be copied with the Copy command. You can select text this way even if the text field is a dynamic text field instead of an input text field.

default

  true

### selectionBeginIndex

selectionBeginIndex: number

Inherited from TextField.selectionBeginIndex

- Defined in lib/openfl/text/TextField.d.ts:522

The zero-based character index value of the first character in the current selection. For example, the first character is 0, the second character is 1, and so on. If no text is selected, this property is the value of `caretIndex`.

### selectionEndIndex

selectionEndIndex: number

Inherited from TextField.selectionEndIndex

- Defined in lib/openfl/text/TextField.d.ts:532

The zero-based character index value of the last character in the current selection. For example, the first character is 0, the second character is 1, and so on. If no text is selected, this property is the value of `caretIndex`.

### shader

shader: Shader

Inherited from DisplayObject.shader

- Defined in lib/openfl/display/DisplayObject.d.ts:653

### sharpness

sharpness: number

Inherited from TextField.sharpness

- Defined in lib/openfl/text/TextField.d.ts:546

The sharpness of the glyph edges in this text field. This property applies only if the `flash.text.AntiAliasType` property of the text field is set to `flash.text.AntiAliasType.ADVANCED`. The range for `sharpness` is a number from -400 to 400. If you attempt to set `sharpness` to a value outside that range, Flash sets the property to the nearest value in the range(either -400 or 400).

default

  0

### softKeyboardInputAreaOfInterest

softKeyboardInputAreaOfInterest: Rectangle

Inherited from InteractiveObject.softKeyboardInputAreaOfInterest

- Defined in lib/openfl/display/InteractiveObject.d.ts:1117

### stage

stage: Stage

Inherited from DisplayObject.stage

- Defined in lib/openfl/display/DisplayObject.d.ts:668

The Stage of the display object. A Flash runtime application has only one Stage object. For example, you can create and load multiple display objects into the display list, and the `stage` property of each display object refers to the same Stage object(even if the display object belongs to a loaded SWF file).

If a display object is not added to the display list, its `stage` property is set to `null`.

### tabEnabled

tabEnabled: boolean

Inherited from InteractiveObject.tabEnabled

- Defined in lib/openfl/display/InteractiveObject.d.ts:1119

### tabIndex

tabIndex: number

Inherited from InteractiveObject.tabIndex

- Defined in lib/openfl/display/InteractiveObject.d.ts:1124

### text

text: string

Inherited from TextField.text

- Defined in lib/openfl/text/TextField.d.ts:559

A string that is the current text in the text field. Lines are separated by the carriage return character(`'\r'`, ASCII 13). This property contains unformatted text in the text field, without HTML tags.

To get the text in HTML form, use the `htmlText` property.

### textColor

textColor: number

Inherited from TextField.textColor

- Defined in lib/openfl/text/TextField.d.ts:573

The color of the text in a text field, in hexadecimal format. The hexadecimal color system uses six digits to represent color values. Each digit has 16 possible values or characters. The characters range from 0-9 and then A-F. For example, black is `0x000000`; white is `0xFFFFFF`.

default

  0(0x000000)

### textHeight

textHeight: number

Inherited from TextField.textHeight

- Defined in lib/openfl/text/TextField.d.ts:581

The height of the text in pixels.

### textWidth

textWidth: number

Inherited from TextField.textWidth

- Defined in lib/openfl/text/TextField.d.ts:588

The width of the text in pixels.

### transform

transform: Transform

Inherited from DisplayObject.transform

- Defined in lib/openfl/display/DisplayObject.d.ts:711

An object with properties pertaining to a display object's matrix, color transform, and pixel bounds. The specific properties - matrix, colorTransform, and three read-only properties (`concatenatedMatrix`, `concatenatedColorTransform`, and `pixelBounds`) - are described in the entry for the Transform class.

Each of the transform object's properties is itself an object. This concept is important because the only way to set new values for the matrix or colorTransform objects is to create a new object and copy that object into the transform.matrix or transform.colorTransform property.

For example, to increase the `tx` value of a display object's matrix, you must make a copy of the entire matrix object, then copy the new object into the matrix property of the transform object: `var myMatrix:Matrix = myDisplayObject.transform.matrix; myMatrix.tx += 10; myDisplayObject.transform.matrix = myMatrix;`

You cannot directly set the `tx` property. The following code has no effect on `myDisplayObject`: `myDisplayObject.transform.matrix.tx += 10;`

You can also copy an entire transform object and assign it to another display object's transform property. For example, the following code copies the entire transform object from `myOldDisplayObj` to `myNewDisplayObj`: `myNewDisplayObj.transform = myOldDisplayObj.transform;`

The resulting display object, `myNewDisplayObj`, now has the same values for its matrix, color transform, and pixel bounds as the old display object, `myOldDisplayObj`.

Note that AIR for TV devices use hardware acceleration, if it is available, for color transforms.

### type

type: TextFieldType

Inherited from TextField.type

- Defined in lib/openfl/text/TextField.d.ts:602

The type of the text field. Either one of the following TextFieldType constants: `TextFieldType.DYNAMIC`, which specifies a dynamic text field, which a user cannot edit, or `TextFieldType.INPUT`, which specifies an input text field, which a user can edit.

default

  dynamic

throws

  ArgumentError The `type` specified is not a member of flash.text.TextFieldType.

### visible

visible: boolean

Inherited from DisplayObject.visible

- Defined in lib/openfl/display/DisplayObject.d.ts:721

Whether or not the display object is visible. Display objects that are not visible are disabled. For example, if `visible=false` for an InteractiveObject instance, it cannot be clicked.

### width

width: number

Inherited from DisplayObject.width

- Defined in lib/openfl/display/DisplayObject.d.ts:736

Indicates the width of the display object, in pixels. The width is calculated based on the bounds of the content of the display object. When you set the `width` property, the `scaleX` property is adjusted accordingly, as shown in the following code:

Except for TextField and Video objects, a display object with no content(such as an empty sprite) has a width of 0, even if you try to set `width` to a different value.

### wordWrap

wordWrap: boolean

Inherited from TextField.wordWrap

- Defined in lib/openfl/text/TextField.d.ts:613

A Boolean value that indicates whether the text field has word wrap. If the value of `wordWrap` is `true`, the text field has word wrap; if the value is `false`, the text field does not have word wrap. The default value is `false`.

### x

x: number

Inherited from DisplayObject.x

- Defined in lib/openfl/display/DisplayObject.d.ts:751

Indicates the _x_ coordinate of the DisplayObject instance relative to the local coordinates of the parent DisplayObjectContainer. If the object is inside a DisplayObjectContainer that has transformations, it is in the local coordinate system of the enclosing DisplayObjectContainer. Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the DisplayObjectContainer's children inherit a coordinate system that is rotated 90° counterclockwise. The object's coordinates refer to the registration point position.

### y

y: number

Inherited from DisplayObject.y

- Defined in lib/openfl/display/DisplayObject.d.ts:766

Indicates the _y_ coordinate of the DisplayObject instance relative to the local coordinates of the parent DisplayObjectContainer. If the object is inside a DisplayObjectContainer that has transformations, it is in the local coordinate system of the enclosing DisplayObjectContainer. Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the DisplayObjectContainer's children inherit a coordinate system that is rotated 90° counterclockwise. The object's coordinates refer to the registration point position.

## Methods

### addEventListener

- addEventListener(type: string, listener: function, useCapture?: boolean, priority?: number, useWeakReference?: boolean): void

- Inherited from EventDispatcher.addEventListener

  - Defined in lib/openfl/events/EventDispatcher.d.ts:168

  Registers an event listener object with an EventDispatcher object so that the listener receives notification of an event. You can register event listeners on all nodes in the display list for a specific type of event, phase, and priority.

  After you successfully register an event listener, you cannot change its priority through additional calls to `addEventListener()`. To change a listener's priority, you must first call `removeListener()`. Then you can register the listener again with the new priority level.

  Keep in mind that after the listener is registered, subsequent calls to `addEventListener()` with a different `type` or `useCapture` value result in the creation of a separate listener registration. For example, if you first register a listener with `useCapture` set to `true`, it listens only during the capture phase. If you call `addEventListener()` again using the same listener object, but with `useCapture` set to `false`, you have two separate listeners: one that listens during the capture phase and another that listens during the target and bubbling phases.

  You cannot register an event listener for only the target phase or the bubbling phase. Those phases are coupled during registration because bubbling applies only to the ancestors of the target node.

  If you no longer need an event listener, remove it by calling `removeEventListener()`, or memory problems could result. Event listeners are not automatically removed from memory because the garbage collector does not remove the listener as long as the dispatching object exists(unless the `useWeakReference` parameter is set to `true`).

  Copying an EventDispatcher instance does not copy the event listeners attached to it.(If your newly created node needs an event listener, you must attach the listener after creating the node.) However, if you move an EventDispatcher instance, the event listeners attached to it move along with it.

  If the event listener is being registered on a node while an event is being processed on this node, the event listener is not triggered during the current phase but can be triggered during a later phase in the event flow, such as the bubbling phase.

  If an event listener is removed from a node while an event is being processed on the node, it is still triggered by the current actions. After it is removed, the event listener is never invoked again(unless registered again for future processing).

  throws

    ArgumentError The `listener` specified is not a function.

  #### Parameters

  - ##### type: string

    The type of event.

  - ##### listener: function

    - - (event: object): void

      - #### Parameters

        - ##### event: object

        #### Returns void

  - ##### Optional useCapture: boolean

    Determines whether the listener works in the capture phase or the target and bubbling phases. If `useCapture` is set to `true`, the listener processes the event only during the capture phase and not in the target or bubbling phase. If `useCapture` is `false`, the listener processes the event only during the target or bubbling phase. To listen for the event in all three phases, call `addEventListener` twice, once with `useCapture` set to `true`, then again with `useCapture` set to `false`.

  - ##### Optional priority: number

    The priority level of the event listener. The priority is designated by a signed 32-bit integer. The higher the number, the higher the priority. All listeners with priority _n_ are processed before listeners of priority _n_-1. If two or more listeners share the same priority, they are processed in the order in which they were added. The default priority is 0.

  - ##### Optional useWeakReference: boolean

    Determines whether the reference to the listener is strong or weak. A strong reference(the default) prevents your listener from being garbage-collected. A weak reference does not.

                            Class-level member functions are not subject to
                            garbage collection, so you can set
                            `useWeakReference` to `true`
                            for class-level member functions without
                            subjecting them to garbage collection. If you set
                            `useWeakReference` to `true`
                            for a listener that is a nested inner function,
                            the function will be garbage-collected and no
                            longer persistent. If you create references to the
                            inner function(save it in another variable) then
                            it is not garbage-collected and stays
                            persistent.

  #### Returns void

### appendText

- appendText(text: string): void

- Inherited from TextField.appendText

  - Defined in lib/openfl/text/TextField.d.ts:639

  Appends the string specified by the `newText` parameter to the end of the text of the text field. This method is more efficient than an addition assignment(`+=`) on a `text` property (such as `someTextField.text += moreText`), particularly for a text field that contains a significant amount of content.

  #### Parameters

  - ##### text: string

  #### Returns void

### dispatchEvent

- dispatchEvent(event: Event): boolean

- Inherited from EventDispatcher.dispatchEvent

  - Defined in lib/openfl/events/EventDispatcher.d.ts:186

  Dispatches an event into the event flow. The event target is the EventDispatcher object upon which the `dispatchEvent()` method is called.

  throws

    Error The event dispatch recursion limit has been reached.

  #### Parameters

  - ##### event: Event

    The Event object that is dispatched into the event flow. If the event is being redispatched, a clone of the event is created automatically. After an event is dispatched, its `target` property cannot be changed, so you must create a new copy of the event for redispatching to work.

  #### Returns boolean

  A value of `true` if the event was successfully dispatched. A value of `false` indicates failure or that `preventDefault()` was called on the event.

### getBounds

- getBounds(targetCoordinateSpace: DisplayObject): Rectangle

- Inherited from DisplayObject.getBounds

  - Defined in lib/openfl/display/DisplayObject.d.ts:799

  Returns a rectangle that defines the area of the display object relative to the coordinate system of the `targetCoordinateSpace` object. Consider the following code, which shows how the rectangle returned can vary depending on the `targetCoordinateSpace` parameter that you pass to the method:

  Note: Use the `localToGlobal()` and `globalToLocal()` methods to convert the display object's local coordinates to display coordinates, or display coordinates to local coordinates, respectively.

  The `getBounds()` method is similar to the `getRect()` method; however, the Rectangle returned by the `getBounds()` method includes any strokes on shapes, whereas the Rectangle returned by the `getRect()` method does not. For an example, see the description of the `getRect()` method.

  #### Parameters

  - ##### targetCoordinateSpace: DisplayObject

    The display object that defines the coordinate system to use.

  #### Returns Rectangle

  The rectangle that defines the area of the display object relative to the `targetCoordinateSpace` object's coordinate system.

### getCharBoundaries

- getCharBoundaries(charIndex: number): Rectangle

- Inherited from TextField.getCharBoundaries

  - Defined in lib/openfl/text/TextField.d.ts:651

  Returns a rectangle that is the bounding box of the character.

  #### Parameters

  - ##### charIndex: number

    The zero-based index value for the character(for example, the first position is 0, the second position is 1, and so on).

  #### Returns Rectangle

  A rectangle with `x` and `y` minimum and maximum values defining the bounding box of the character.

### getCharIndexAtPoint

- getCharIndexAtPoint(x: number, y: number): number

- Inherited from TextField.getCharIndexAtPoint

  - Defined in lib/openfl/text/TextField.d.ts:664

  Returns the zero-based index value of the character at the point specified by the `x` and `y` parameters.

  #### Parameters

  - ##### x: number

    The _x_ coordinate of the character.

  - ##### y: number

    The _y_ coordinate of the character.

  #### Returns number

  The zero-based index value of the character(for example, the first position is 0, the second position is 1, and so on). Returns -1 if the point is not over any character.

### getFirstCharInParagraph

- getFirstCharInParagraph(charIndex: number): number

- Inherited from TextField.getFirstCharInParagraph

  - Defined in lib/openfl/text/TextField.d.ts:667

  #### Parameters

  - ##### charIndex: number

  #### Returns number

### getLineIndexAtPoint

- getLineIndexAtPoint(x: number, y: number): number

- Inherited from TextField.getLineIndexAtPoint

  - Defined in lib/openfl/text/TextField.d.ts:680

  Returns the zero-based index value of the line at the point specified by the `x` and `y` parameters.

  #### Parameters

  - ##### x: number

    The _x_ coordinate of the line.

  - ##### y: number

    The _y_ coordinate of the line.

  #### Returns number

  The zero-based index value of the line(for example, the first line is 0, the second line is 1, and so on). Returns -1 if the point is not over any line.

### getLineIndexOfChar

- getLineIndexOfChar(charIndex: number): number

- Inherited from TextField.getLineIndexOfChar

  - Defined in lib/openfl/text/TextField.d.ts:683

  #### Parameters

  - ##### charIndex: number

  #### Returns number

### getLineLength

- getLineLength(lineIndex: number): number

- Inherited from TextField.getLineLength

  - Defined in lib/openfl/text/TextField.d.ts:686

  #### Parameters

  - ##### lineIndex: number

  #### Returns number

### getLineMetrics

- getLineMetrics(lineIndex: number): TextLineMetrics

- Inherited from TextField.getLineMetrics

  - Defined in lib/openfl/text/TextField.d.ts:696

  Returns metrics information about a given text line.

  throws

    RangeError The line number specified is out of range.

  #### Parameters

  - ##### lineIndex: number

    The line number for which you want metrics information.

  #### Returns TextLineMetrics

  A TextLineMetrics object.

### getLineOffset

- getLineOffset(lineIndex: number): number

- Inherited from TextField.getLineOffset

  - Defined in lib/openfl/text/TextField.d.ts:708

  Returns the character index of the first character in the line that the `lineIndex` parameter specifies.

  throws

    RangeError The line number specified is out of range.

  #### Parameters

  - ##### lineIndex: number

    The zero-based index value of the line(for example, the first line is 0, the second line is 1, and so on).

  #### Returns number

  The zero-based index value of the first character in the line.

### getLineText

- getLineText(lineIndex: number): string

- Inherited from TextField.getLineText

  - Defined in lib/openfl/text/TextField.d.ts:720

  Returns the text of the line specified by the `lineIndex` parameter.

  throws

    RangeError The line number specified is out of range.

  #### Parameters

  - ##### lineIndex: number

    The zero-based index value of the line(for example, the first line is 0, the second line is 1, and so on).

  #### Returns string

  The text string contained in the specified line.

### getParagraphLength

- getParagraphLength(charIndex: number): number

- Inherited from TextField.getParagraphLength

  - Defined in lib/openfl/text/TextField.d.ts:723

  #### Parameters

  - ##### charIndex: number

  #### Returns number

### getRect

- getRect(targetCoordinateSpace: DisplayObject): Rectangle

- Inherited from DisplayObject.getRect

  - Defined in lib/openfl/display/DisplayObject.d.ts:820

  Returns a rectangle that defines the boundary of the display object, based on the coordinate system defined by the `targetCoordinateSpace` parameter, excluding any strokes on shapes. The values that the `getRect()` method returns are the same or smaller than those returned by the `getBounds()` method.

  Note: Use `localToGlobal()` and `globalToLocal()` methods to convert the display object's local coordinates to Stage coordinates, or Stage coordinates to local coordinates, respectively.

  #### Parameters

  - ##### targetCoordinateSpace: DisplayObject

    The display object that defines the coordinate system to use.

  #### Returns Rectangle

  The rectangle that defines the area of the display object relative to the `targetCoordinateSpace` object's coordinate system.

### getTextFormat

- getTextFormat(beginIndex?: number, endIndex?: number): TextFormat

- Inherited from TextField.getTextFormat

  - Defined in lib/openfl/text/TextField.d.ts:744

  Returns a TextFormat object that contains formatting information for the range of text that the `beginIndex` and `endIndex` parameters specify. Only properties that are common to the entire text specified are set in the resulting TextFormat object. Any property that is mixed, meaning that it has different values at different points in the text, has a value of `null`.

  If you do not specify values for these parameters, this method is applied to all the text in the text field.

  The following table describes three possible usages:

  throws

    RangeError The `beginIndex` or `endIndex` specified is out of range.

  #### Parameters

  - ##### Optional beginIndex: number

  - ##### Optional endIndex: number

  #### Returns TextFormat

  The TextFormat object that represents the formatting properties for the specified text.

### Protected get_alpha

- get_alpha(): number

- Inherited from DisplayObject.get_alpha

  - Defined in lib/openfl/display/DisplayObject.d.ts:163

  #### Returns number

### Protected get_antiAliasType

- get_antiAliasType(): AntiAliasType

- Inherited from TextField.get_antiAliasType

  - Defined in lib/openfl/text/TextField.d.ts:107

  #### Returns AntiAliasType

### Protected get_autoSize

- get_autoSize(): TextFieldAutoSize

- Inherited from TextField.get_autoSize

  - Defined in lib/openfl/text/TextField.d.ts:154

  #### Returns TextFieldAutoSize

### Protected get_background

- get_background(): boolean

- Inherited from TextField.get_background

  - Defined in lib/openfl/text/TextField.d.ts:168

  #### Returns boolean

### Protected get_backgroundColor

- get_backgroundColor(): number

- Inherited from TextField.get_backgroundColor

  - Defined in lib/openfl/text/TextField.d.ts:180

  #### Returns number

### Protected get_blendMode

- get_blendMode(): BlendMode

- Inherited from DisplayObject.get_blendMode

  - Defined in lib/openfl/display/DisplayObject.d.ts:192

  #### Returns BlendMode

### Protected get_border

- get_border(): boolean

- Inherited from TextField.get_border

  - Defined in lib/openfl/text/TextField.d.ts:192

  #### Returns boolean

### Protected get_borderColor

- get_borderColor(): number

- Inherited from TextField.get_borderColor

  - Defined in lib/openfl/text/TextField.d.ts:203

  #### Returns number

### Protected get_bottomScrollV

- get_bottomScrollV(): number

- Inherited from TextField.get_bottomScrollV

  - Defined in lib/openfl/text/TextField.d.ts:217

  #### Returns number

### Protected get_cacheAsBitmap

- get_cacheAsBitmap(): boolean

- Inherited from DisplayObject.get_cacheAsBitmap

  - Defined in lib/openfl/display/DisplayObject.d.ts:253

  #### Returns boolean

### Protected get_cacheAsBitmapMatrix

- get_cacheAsBitmapMatrix(): Matrix

- Inherited from DisplayObject.get_cacheAsBitmapMatrix

  - Defined in lib/openfl/display/DisplayObject.d.ts:258

  #### Returns Matrix

### Protected get_caretIndex

- get_caretIndex(): number

- Inherited from TextField.get_caretIndex

  - Defined in lib/openfl/text/TextField.d.ts:230

  #### Returns number

### Protected get_defaultTextFormat

- get_defaultTextFormat(): TextFormat

- Inherited from TextField.get_defaultTextFormat

  - Defined in lib/openfl/text/TextField.d.ts:264

  #### Returns TextFormat

### Protected get_displayAsPassword

- get_displayAsPassword(): boolean

- Inherited from TextField.get_displayAsPassword

  - Defined in lib/openfl/text/TextField.d.ts:281

  #### Returns boolean

### Protected get_embedFonts

- get_embedFonts(): boolean

- Inherited from TextField.get_embedFonts

  - Defined in lib/openfl/text/TextField.d.ts:299

  #### Returns boolean

### Protected get_filters

- get_filters(): Array<BitmapFilter>

- Inherited from DisplayObject.get_filters

  - Defined in lib/openfl/display/DisplayObject.d.ts:339

  #### Returns Array<BitmapFilter>

### Protected get_gridFitType

- get_gridFitType(): GridFitType

- Inherited from TextField.get_gridFitType

  - Defined in lib/openfl/text/TextField.d.ts:318

  #### Returns GridFitType

### Protected get_height

- get_height(): number

- Inherited from DisplayObject.get_height

  - Defined in lib/openfl/display/DisplayObject.d.ts:354

  #### Returns number

### Protected get_htmlText

- get_htmlText(): string

- Inherited from TextField.get_htmlText

  - Defined in lib/openfl/text/TextField.d.ts:331

  #### Returns string

### Protected get_length

- get_length(): number

- Inherited from TextField.get_length

  - Defined in lib/openfl/text/TextField.d.ts:340

  #### Returns number

### Protected get_loaderInfo

- get_loaderInfo(): LoaderInfo

- Inherited from DisplayObject.get_loaderInfo

  - Defined in lib/openfl/display/DisplayObject.d.ts:372

  #### Returns LoaderInfo

### Protected get_mask

- get_mask(): DisplayObject

- Inherited from DisplayObject.get_mask

  - Defined in lib/openfl/display/DisplayObject.d.ts:407

  #### Returns DisplayObject

### Protected get_maxChars

- get_maxChars(): number

- Inherited from TextField.get_maxChars

  - Defined in lib/openfl/text/TextField.d.ts:354

  #### Returns number

### Protected get_maxScrollH

- get_maxScrollH(): number

- Inherited from TextField.get_maxScrollH

  - Defined in lib/openfl/text/TextField.d.ts:362

  #### Returns number

### Protected get_maxScrollV

- get_maxScrollV(): number

- Inherited from TextField.get_maxScrollV

  - Defined in lib/openfl/text/TextField.d.ts:369

  #### Returns number

### Protected get_mouseWheelEnabled

- get_mouseWheelEnabled(): boolean

- Inherited from TextField.get_mouseWheelEnabled

  - Defined in lib/openfl/text/TextField.d.ts:373

  #### Returns boolean

### Protected get_mouseX

- get_mouseX(): number

- Inherited from DisplayObject.get_mouseX

  - Defined in lib/openfl/display/DisplayObject.d.ts:419

  #### Returns number

### Protected get_mouseY

- get_mouseY(): number

- Inherited from DisplayObject.get_mouseY

  - Defined in lib/openfl/display/DisplayObject.d.ts:430

  #### Returns number

### Protected get_multiline

- get_multiline(): boolean

- Inherited from TextField.get_multiline

  - Defined in lib/openfl/text/TextField.d.ts:390

  #### Returns boolean

### Protected get_name

- get_name(): string

- Inherited from DisplayObject.get_name

  - Defined in lib/openfl/display/DisplayObject.d.ts:444

  #### Returns string

### Protected get_numLines

- get_numLines(): number

- Inherited from TextField.get_numLines

  - Defined in lib/openfl/text/TextField.d.ts:400

  #### Returns number

### Protected get_restrict

- get_restrict(): string

- Inherited from TextField.get_restrict

  - Defined in lib/openfl/text/TextField.d.ts:450

  #### Returns string

### Protected get_root

- get_root(): DisplayObject

- Inherited from DisplayObject.get_root

  - Defined in lib/openfl/display/DisplayObject.d.ts:517

  #### Returns DisplayObject

### Protected get_rotation

- get_rotation(): number

- Inherited from DisplayObject.get_rotation

  - Defined in lib/openfl/display/DisplayObject.d.ts:529

  #### Returns number

### Protected get_scaleX

- get_scaleX(): number

- Inherited from DisplayObject.get_scaleX

  - Defined in lib/openfl/display/DisplayObject.d.ts:606

  #### Returns number

### Protected get_scaleY

- get_scaleY(): number

- Inherited from DisplayObject.get_scaleY

  - Defined in lib/openfl/display/DisplayObject.d.ts:619

  #### Returns number

### Protected get_scrollH

- get_scrollH(): number

- Inherited from TextField.get_scrollH

  - Defined in lib/openfl/text/TextField.d.ts:471

  #### Returns number

### Protected get_scrollRect

- get_scrollRect(): Rectangle

- Inherited from DisplayObject.get_scrollRect

  - Defined in lib/openfl/display/DisplayObject.d.ts:650

  #### Returns Rectangle

### Protected get_scrollV

- get_scrollV(): number

- Inherited from TextField.get_scrollV

  - Defined in lib/openfl/text/TextField.d.ts:490

  #### Returns number

### Protected get_selectable

- get_selectable(): boolean

- Inherited from TextField.get_selectable

  - Defined in lib/openfl/text/TextField.d.ts:513

  #### Returns boolean

### Protected get_selectionBeginIndex

- get_selectionBeginIndex(): number

- Inherited from TextField.get_selectionBeginIndex

  - Defined in lib/openfl/text/TextField.d.ts:524

  #### Returns number

### Protected get_selectionEndIndex

- get_selectionEndIndex(): number

- Inherited from TextField.get_selectionEndIndex

  - Defined in lib/openfl/text/TextField.d.ts:534

  #### Returns number

### Protected get_shader

- get_shader(): Shader

- Inherited from DisplayObject.get_shader

  - Defined in lib/openfl/display/DisplayObject.d.ts:655

  #### Returns Shader

### Protected get_sharpness

- get_sharpness(): number

- Inherited from TextField.get_sharpness

  - Defined in lib/openfl/text/TextField.d.ts:548

  #### Returns number

### Protected get_stage

- get_stage(): Stage

- Inherited from DisplayObject.get_stage

  - Defined in lib/openfl/display/DisplayObject.d.ts:670

  #### Returns Stage

### Protected get_tabEnabled

- get_tabEnabled(): boolean

- Inherited from InteractiveObject.get_tabEnabled

  - Defined in lib/openfl/display/InteractiveObject.d.ts:1121

  #### Returns boolean

### Protected get_tabIndex

- get_tabIndex(): number

- Inherited from InteractiveObject.get_tabIndex

  - Defined in lib/openfl/display/InteractiveObject.d.ts:1126

  #### Returns number

### Protected get_text

- get_text(): string

- Inherited from TextField.get_text

  - Defined in lib/openfl/text/TextField.d.ts:561

  #### Returns string

### Protected get_textColor

- get_textColor(): number

- Inherited from TextField.get_textColor

  - Defined in lib/openfl/text/TextField.d.ts:575

  #### Returns number

### Protected get_textHeight

- get_textHeight(): number

- Inherited from TextField.get_textHeight

  - Defined in lib/openfl/text/TextField.d.ts:583

  #### Returns number

### Protected get_textWidth

- get_textWidth(): number

- Inherited from TextField.get_textWidth

  - Defined in lib/openfl/text/TextField.d.ts:590

  #### Returns number

### Protected get_transform

- get_transform(): Transform

- Inherited from DisplayObject.get_transform

  - Defined in lib/openfl/display/DisplayObject.d.ts:713

  #### Returns Transform

### Protected get_type

- get_type(): TextFieldType

- Inherited from TextField.get_type

  - Defined in lib/openfl/text/TextField.d.ts:604

  #### Returns TextFieldType

### Protected get_visible

- get_visible(): boolean

- Inherited from DisplayObject.get_visible

  - Defined in lib/openfl/display/DisplayObject.d.ts:723

  #### Returns boolean

### Protected get_width

- get_width(): number

- Inherited from DisplayObject.get_width

  - Defined in lib/openfl/display/DisplayObject.d.ts:738

  #### Returns number

### Protected get_wordWrap

- get_wordWrap(): boolean

- Inherited from TextField.get_wordWrap

  - Defined in lib/openfl/text/TextField.d.ts:615

  #### Returns boolean

### Protected get_x

- get_x(): number

- Inherited from DisplayObject.get_x

  - Defined in lib/openfl/display/DisplayObject.d.ts:753

  #### Returns number

### Protected get_y

- get_y(): number

- Inherited from DisplayObject.get_y

  - Defined in lib/openfl/display/DisplayObject.d.ts:768

  #### Returns number

### globalToLocal

- globalToLocal(pos: Point): Point

- Inherited from DisplayObject.globalToLocal

  - Defined in lib/openfl/display/DisplayObject.d.ts:840

  Converts the `point` object from the Stage(global) coordinates to the display object's(local) coordinates.

  To use this method, first create an instance of the Point class. The _x_ and _y_ values that you assign represent global coordinates because they relate to the origin(0,0) of the main display area. Then pass the Point instance as the parameter to the `globalToLocal()` method. The method returns a new Point object with _x_ and _y_ values that relate to the origin of the display object instead of the origin of the Stage.

  #### Parameters

  - ##### pos: Point

  #### Returns Point

  A Point object with coordinates relative to the display object.

### hasEventListener

- hasEventListener(type: string): boolean

- Inherited from EventDispatcher.hasEventListener

  - Defined in lib/openfl/events/EventDispatcher.d.ts:209

  Checks whether the EventDispatcher object has any listeners registered for a specific type of event. This allows you to determine where an EventDispatcher object has altered handling of an event type in the event flow hierarchy. To determine whether a specific event type actually triggers an event listener, use `willTrigger()`.

  The difference between `hasEventListener()` and `willTrigger()` is that `hasEventListener()` examines only the object to which it belongs, whereas `willTrigger()` examines the entire event flow for the event specified by the `type` parameter.

  When `hasEventListener()` is called from a LoaderInfo object, only the listeners that the caller can access are considered.

  #### Parameters

  - ##### type: string

    The type of event.

  #### Returns boolean

  A value of `true` if a listener of the specified type is registered; `false` otherwise.

### hitTestObject

- hitTestObject(obj: DisplayObject): boolean

- Inherited from DisplayObject.hitTestObject

  - Defined in lib/openfl/display/DisplayObject.d.ts:856

  Evaluates the bounding box of the display object to see if it overlaps or intersects with the bounding box of the `obj` display object.

  #### Parameters

  - ##### obj: DisplayObject

    The display object to test against.

  #### Returns boolean

  `true` if the bounding boxes of the display objects intersect; `false` if not.

### hitTestPoint

- hitTestPoint(x: number, y: number, shapeFlag?: boolean): boolean

- Inherited from DisplayObject.hitTestPoint

  - Defined in lib/openfl/display/DisplayObject.d.ts:875

  Evaluates the display object to see if it overlaps or intersects with the point specified by the `x` and `y` parameters. The `x` and `y` parameters specify a point in the coordinate space of the Stage, not the display object container that contains the display object(unless that display object container is the Stage).

  #### Parameters

  - ##### x: number

    The _x_ coordinate to test against this object.

  - ##### y: number

    The _y_ coordinate to test against this object.

  - ##### Optional shapeFlag: boolean

    Whether to check against the actual pixels of the object (`true`) or the bounding box (`false`).

  #### Returns boolean

  `true` if the display object overlaps or intersects with the specified point; `false` otherwise.

### invalidate

- invalidate(): void

- Inherited from DisplayObject.invalidate

  - Defined in lib/openfl/display/DisplayObject.d.ts:882

  Calling the `invalidate()` method signals to have the current object redrawn the next time the object is eligible to be rendered.

  #### Returns void

### localToGlobal

- localToGlobal(point: Point): Point

- Inherited from DisplayObject.localToGlobal

  - Defined in lib/openfl/display/DisplayObject.d.ts:907

  Converts the `point` object from the display object's(local) coordinates to the Stage(global) coordinates.

  This method allows you to convert any given _x_ and _y_ coordinates from values that are relative to the origin(0,0) of a specific display object(local coordinates) to values that are relative to the origin of the Stage(global coordinates).

  To use this method, first create an instance of the Point class. The _x_ and _y_ values that you assign represent local coordinates because they relate to the origin of the display object.

  You then pass the Point instance that you created as the parameter to the `localToGlobal()` method. The method returns a new Point object with _x_ and _y_ values that relate to the origin of the Stage instead of the origin of the display object.

  #### Parameters

  - ##### point: Point

    The name or identifier of a point created with the Point class, specifying the _x_ and _y_ coordinates as properties.

  #### Returns Point

  A Point object with coordinates relative to the Stage.

### removeEventListener

- removeEventListener(type: string, listener: function, useCapture?: boolean): void

- Inherited from EventDispatcher.removeEventListener

  - Defined in lib/openfl/events/EventDispatcher.d.ts:227

  Removes a listener from the EventDispatcher object. If there is no matching listener registered with the EventDispatcher object, a call to this method has no effect.

  #### Parameters

  - ##### type: string

    The type of event.

  - ##### listener: function

    - - (event: object): void

      - #### Parameters

        - ##### event: object

        #### Returns void

  - ##### Optional useCapture: boolean

    Specifies whether the listener was registered for the capture phase or the target and bubbling phases. If the listener was registered for both the capture phase and the target and bubbling phases, two calls to `removeEventListener()` are required to remove both, one call with `useCapture()` set to `true`, and another call with `useCapture()` set to `false`.

  #### Returns void

### replaceSelectedText

- replaceSelectedText(value: string): void

- Inherited from TextField.replaceSelectedText

  - Defined in lib/openfl/text/TextField.d.ts:747

  #### Parameters

  - ##### value: string

  #### Returns void

### replaceText

- replaceText(beginIndex: number, endIndex: number, newText: string): void

- Inherited from TextField.replaceText

  - Defined in lib/openfl/text/TextField.d.ts:750

  #### Parameters

  - ##### beginIndex: number

  - ##### endIndex: number

  - ##### newText: string

  #### Returns void

### requestSoftKeyboard

- requestSoftKeyboard(): boolean

- Inherited from InteractiveObject.requestSoftKeyboard

  - Defined in lib/openfl/display/InteractiveObject.d.ts:1161

  Raises a virtual keyboard.

  Calling this method focuses the InteractiveObject instance and raises the soft keyboard, if necessary. The `needsSoftKeyboard` must also be `true`. A keyboard is not raised if a hardware keyboard is available, or if the client system does not support virtual keyboards.

  Note: This method is not supported in AIR applications on iOS.

  #### Returns boolean

  A value of `true` means that the soft keyboard request was granted; `false` means that the soft keyboard was not raised.

### setSelection

- setSelection(beginIndex: number, endIndex: number): void

- Inherited from TextField.setSelection

  - Defined in lib/openfl/text/TextField.d.ts:766

  Sets as selected the text designated by the index values of the first and last characters, which are specified with the `beginIndex` and `endIndex` parameters. If the two parameter values are the same, this method sets the insertion point, as if you set the `caretIndex` property.

  #### Parameters

  - ##### beginIndex: number

    The zero-based index value of the first character in the selection(for example, the first character is 0, the second character is 1, and so on).

  - ##### endIndex: number

    The zero-based index value of the last character in the selection.

  #### Returns void

### setTextFormat

- setTextFormat(format: TextFormat, beginIndex?: number, endIndex?: number): void

- Inherited from TextField.setTextFormat

  - Defined in lib/openfl/text/TextField.d.ts:814

  Applies the text formatting that the `format` parameter specifies to the specified text in a text field. The value of `format` must be a TextFormat object that specifies the desired text formatting changes. Only the non-null properties of `format` are applied to the text field. Any property of `format` that is set to `null` is not applied. By default, all of the properties of a newly created TextFormat object are set to `null`.

  Note: This method does not work if a style sheet is applied to the text field.

  The `setTextFormat()` method changes the text formatting applied to a range of characters or to the entire body of text in a text field. To apply the properties of format to all text in the text field, do not specify values for `beginIndex` and `endIndex`. To apply the properties of the format to a range of text, specify values for the `beginIndex` and the `endIndex` parameters. You can use the `length` property to determine the index values.

  The two types of formatting information in a TextFormat object are character level formatting and paragraph level formatting. Each character in a text field can have its own character formatting settings, such as font name, font size, bold, and italic.

  For paragraphs, the first character of the paragraph is examined for the paragraph formatting settings for the entire paragraph. Examples of paragraph formatting settings are left margin, right margin, and indentation.

  Any text inserted manually by the user, or replaced by the `replaceSelectedText()` method, receives the default text field formatting for new text, and not the formatting specified for the text insertion point. To set the default formatting for new text, use `defaultTextFormat`.

  throws

    Error This method cannot be used on a text field with a style sheet.

  throws

    RangeError The `beginIndex` or `endIndex` specified is out of range.

  #### Parameters

  - ##### format: TextFormat

    A TextFormat object that contains character and paragraph formatting information.

  - ##### Optional beginIndex: number

  - ##### Optional endIndex: number

  #### Returns void

### Protected set_alpha

- set_alpha(value: number): number

- Inherited from DisplayObject.set_alpha

  - Defined in lib/openfl/display/DisplayObject.d.ts:164

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_antiAliasType

- set_antiAliasType(value: AntiAliasType): AntiAliasType

- Inherited from TextField.set_antiAliasType

  - Defined in lib/openfl/text/TextField.d.ts:108

  #### Parameters

  - ##### value: AntiAliasType

  #### Returns AntiAliasType

### Protected set_autoSize

- set_autoSize(value: TextFieldAutoSize): TextFieldAutoSize

- Inherited from TextField.set_autoSize

  - Defined in lib/openfl/text/TextField.d.ts:155

  #### Parameters

  - ##### value: TextFieldAutoSize

  #### Returns TextFieldAutoSize

### Protected set_background

- set_background(value: boolean): boolean

- Inherited from TextField.set_background

  - Defined in lib/openfl/text/TextField.d.ts:169

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_backgroundColor

- set_backgroundColor(value: number): number

- Inherited from TextField.set_backgroundColor

  - Defined in lib/openfl/text/TextField.d.ts:181

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_blendMode

- set_blendMode(value: BlendMode): BlendMode

- Inherited from DisplayObject.set_blendMode

  - Defined in lib/openfl/display/DisplayObject.d.ts:193

  #### Parameters

  - ##### value: BlendMode

  #### Returns BlendMode

### Protected set_border

- set_border(value: boolean): boolean

- Inherited from TextField.set_border

  - Defined in lib/openfl/text/TextField.d.ts:193

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_borderColor

- set_borderColor(value: number): number

- Inherited from TextField.set_borderColor

  - Defined in lib/openfl/text/TextField.d.ts:204

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_cacheAsBitmap

- set_cacheAsBitmap(value: boolean): boolean

- Inherited from DisplayObject.set_cacheAsBitmap

  - Defined in lib/openfl/display/DisplayObject.d.ts:254

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_cacheAsBitmapMatrix

- set_cacheAsBitmapMatrix(value: Matrix): Matrix

- Inherited from DisplayObject.set_cacheAsBitmapMatrix

  - Defined in lib/openfl/display/DisplayObject.d.ts:259

  #### Parameters

  - ##### value: Matrix

  #### Returns Matrix

### Protected set_caretIndex

- set_caretIndex(value: number): number

- Inherited from TextField.set_caretIndex

  - Defined in lib/openfl/text/TextField.d.ts:231

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_defaultTextFormat

- set_defaultTextFormat(value: TextFormat): TextFormat

- Inherited from TextField.set_defaultTextFormat

  - Defined in lib/openfl/text/TextField.d.ts:265

  #### Parameters

  - ##### value: TextFormat

  #### Returns TextFormat

### Protected set_displayAsPassword

- set_displayAsPassword(value: boolean): boolean

- Inherited from TextField.set_displayAsPassword

  - Defined in lib/openfl/text/TextField.d.ts:282

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_embedFonts

- set_embedFonts(value: boolean): boolean

- Inherited from TextField.set_embedFonts

  - Defined in lib/openfl/text/TextField.d.ts:300

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_filters

- set_filters(value: Array<BitmapFilter>): Array<BitmapFilter>

- Inherited from DisplayObject.set_filters

  - Defined in lib/openfl/display/DisplayObject.d.ts:340

  #### Parameters

  - ##### value: Array<BitmapFilter>

  #### Returns Array<BitmapFilter>

### Protected set_gridFitType

- set_gridFitType(value: GridFitType): GridFitType

- Inherited from TextField.set_gridFitType

  - Defined in lib/openfl/text/TextField.d.ts:319

  #### Parameters

  - ##### value: GridFitType

  #### Returns GridFitType

### Protected set_height

- set_height(value: number): number

- Inherited from DisplayObject.set_height

  - Defined in lib/openfl/display/DisplayObject.d.ts:355

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_htmlText

- set_htmlText(value: string): string

- Inherited from TextField.set_htmlText

  - Defined in lib/openfl/text/TextField.d.ts:332

  #### Parameters

  - ##### value: string

  #### Returns string

### Protected set_length

- set_length(value: number): number

- Inherited from TextField.set_length

  - Defined in lib/openfl/text/TextField.d.ts:341

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_mask

- set_mask(value: DisplayObject): DisplayObject

- Inherited from DisplayObject.set_mask

  - Defined in lib/openfl/display/DisplayObject.d.ts:408

  #### Parameters

  - ##### value: DisplayObject

  #### Returns DisplayObject

### Protected set_maxChars

- set_maxChars(value: number): number

- Inherited from TextField.set_maxChars

  - Defined in lib/openfl/text/TextField.d.ts:355

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_mouseWheelEnabled

- set_mouseWheelEnabled(value: boolean): boolean

- Inherited from TextField.set_mouseWheelEnabled

  - Defined in lib/openfl/text/TextField.d.ts:374

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_multiline

- set_multiline(value: boolean): boolean

- Inherited from TextField.set_multiline

  - Defined in lib/openfl/text/TextField.d.ts:391

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_name

- set_name(value: string): string

- Inherited from DisplayObject.set_name

  - Defined in lib/openfl/display/DisplayObject.d.ts:445

  #### Parameters

  - ##### value: string

  #### Returns string

### Protected set_restrict

- set_restrict(value: string): string

- Inherited from TextField.set_restrict

  - Defined in lib/openfl/text/TextField.d.ts:451

  #### Parameters

  - ##### value: string

  #### Returns string

### Protected set_rotation

- set_rotation(value: number): number

- Inherited from DisplayObject.set_rotation

  - Defined in lib/openfl/display/DisplayObject.d.ts:530

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_scaleX

- set_scaleX(value: number): number

- Inherited from DisplayObject.set_scaleX

  - Defined in lib/openfl/display/DisplayObject.d.ts:607

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_scaleY

- set_scaleY(value: number): number

- Inherited from DisplayObject.set_scaleY

  - Defined in lib/openfl/display/DisplayObject.d.ts:620

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_scrollH

- set_scrollH(value: number): number

- Inherited from TextField.set_scrollH

  - Defined in lib/openfl/text/TextField.d.ts:472

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_scrollRect

- set_scrollRect(value: Rectangle): Rectangle

- Inherited from DisplayObject.set_scrollRect

  - Defined in lib/openfl/display/DisplayObject.d.ts:651

  #### Parameters

  - ##### value: Rectangle

  #### Returns Rectangle

### Protected set_scrollV

- set_scrollV(value: number): number

- Inherited from TextField.set_scrollV

  - Defined in lib/openfl/text/TextField.d.ts:491

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_selectable

- set_selectable(value: boolean): boolean

- Inherited from TextField.set_selectable

  - Defined in lib/openfl/text/TextField.d.ts:514

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_shader

- set_shader(value: Shader): Shader

- Inherited from DisplayObject.set_shader

  - Defined in lib/openfl/display/DisplayObject.d.ts:656

  #### Parameters

  - ##### value: Shader

  #### Returns Shader

### Protected set_sharpness

- set_sharpness(value: number): number

- Inherited from TextField.set_sharpness

  - Defined in lib/openfl/text/TextField.d.ts:549

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_stage

- set_stage(value: Stage): Stage

- Inherited from DisplayObject.set_stage

  - Defined in lib/openfl/display/DisplayObject.d.ts:671

  #### Parameters

  - ##### value: Stage

  #### Returns Stage

### Protected set_tabEnabled

- set_tabEnabled(value: boolean): boolean

- Inherited from InteractiveObject.set_tabEnabled

  - Defined in lib/openfl/display/InteractiveObject.d.ts:1122

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_tabIndex

- set_tabIndex(value: number): number

- Inherited from InteractiveObject.set_tabIndex

  - Defined in lib/openfl/display/InteractiveObject.d.ts:1127

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_text

- set_text(value: string): string

- Inherited from TextField.set_text

  - Defined in lib/openfl/text/TextField.d.ts:562

  #### Parameters

  - ##### value: string

  #### Returns string

### Protected set_textColor

- set_textColor(value: number): number

- Inherited from TextField.set_textColor

  - Defined in lib/openfl/text/TextField.d.ts:576

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_transform

- set_transform(value: Transform): Transform

- Inherited from DisplayObject.set_transform

  - Defined in lib/openfl/display/DisplayObject.d.ts:714

  #### Parameters

  - ##### value: Transform

  #### Returns Transform

### Protected set_type

- set_type(value: TextFieldType): TextFieldType

- Inherited from TextField.set_type

  - Defined in lib/openfl/text/TextField.d.ts:605

  #### Parameters

  - ##### value: TextFieldType

  #### Returns TextFieldType

### Protected set_visible

- set_visible(value: boolean): boolean

- Inherited from DisplayObject.set_visible

  - Defined in lib/openfl/display/DisplayObject.d.ts:724

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_width

- set_width(value: number): number

- Inherited from DisplayObject.set_width

  - Defined in lib/openfl/display/DisplayObject.d.ts:739

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_wordWrap

- set_wordWrap(value: boolean): boolean

- Inherited from TextField.set_wordWrap

  - Defined in lib/openfl/text/TextField.d.ts:616

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_x

- set_x(value: number): number

- Inherited from DisplayObject.set_x

  - Defined in lib/openfl/display/DisplayObject.d.ts:754

  #### Parameters

  - ##### value: number

  #### Returns number

### Protected set_y

- set_y(value: number): number

- Inherited from DisplayObject.set_y

  - Defined in lib/openfl/display/DisplayObject.d.ts:769

  #### Parameters

  - ##### value: number

  #### Returns number

### toString

- toString(): string

- Inherited from EventDispatcher.toString

  - Defined in lib/openfl/events/EventDispatcher.d.ts:230

  #### Returns string

### willTrigger

- willTrigger(type: string): boolean

- Inherited from EventDispatcher.willTrigger

  - Defined in lib/openfl/events/EventDispatcher.d.ts:253

  Checks whether an event listener is registered with this EventDispatcher object or any of its ancestors for the specified event type. This method returns `true` if an event listener is triggered during any phase of the event flow when an event of the specified type is dispatched to this EventDispatcher object or any of its descendants.

  The difference between the `hasEventListener()` and the `willTrigger()` methods is that `hasEventListener()` examines only the object to which it belongs, whereas the `willTrigger()` method examines the entire event flow for the event specified by the `type` parameter.

  When `willTrigger()` is called from a LoaderInfo object, only the listeners that the caller can access are considered.

  #### Parameters

  - ##### type: string

    The type of event.

  #### Returns boolean

  A value of `true` if a listener of the specified type will be triggered; `false` otherwise.

Generated using TypeDoc